﻿using System;
using System.Text.Json;

namespace SharpChat.EventStorage {
    public class StoredEventInfo {
        public long Id { get; set; }
        public string Type { get; set; }
        public ChatUser Sender { get; set; }
        public DateTimeOffset Created { get; set; }
        public DateTimeOffset? Deleted { get; set; }
        public string ChannelName { get; set; }
        public StoredEventFlags Flags { get; set; }
        public JsonDocument Data { get; set; }

        public StoredEventInfo(
            long id,
            string type,
            ChatUser sender,
            DateTimeOffset created,
            DateTimeOffset? deleted,
            string channelName,
            JsonDocument data,
            StoredEventFlags flags
        ) {
            Id = id;
            Type = type;
            Sender = sender;
            Created = created;
            Deleted = deleted;
            ChannelName = channelName;
            Data = data;
            Flags = flags;
        }
    }
}
